SD_BUS_ADD_MATCH(3)

NAME
sd_bus_add_match - Add a match rule for message dispatching

SYNOPSIS

#include <systemd/sd-bus.h>

int sd_bus_add_match(sd_bus *bus, sd_bus_slot **slot, const char *match, sd_bus_message_handler_t callback, void *userdata);

typedef int (*sd_bus_message_handler_t)(sd_bus_message *m, void *userdata, sd_bus_error *ret_error);

DESCRIPTION

sd_bus_add_match() adds a match rule used to dispatch incoming messages. The syntax of the rule passed in match is described in the D-Bus Specification[1].

The message m passed to the callback is only borrowed, that is, the callback should not call sd_bus_message_unref(3) on it. If the callback wants to hold on to the message beyond the lifetime of the callback, it needs to call sd_bus_message_ref(3) to create a new reference.

If an error occurs during the callback invocation, the callback should return a negative error number. If it wants other callbacks that match the same rule to be called, it should return 0. Otherwise it should return a positive integer.

RETURN VALUE

On success, sd_bus_add_match() returns 0 or a positive integer. On failure, it returns a negative errno-style error code.

SEE ALSO

systemd(1), sd-bus(3),

NOTES

1.  D-Bus Specification
    https://dbus.freedesktop.org/doc/dbus-specification.html